﻿# -*- coding: utf-8 -*-
import urllib, urllib2
import urlparse
import json
import re

def httpget(url):
	file = urllib2.urlopen(url)
	content = file.read()
	file.close()
	return content

def live(url):
	try:
		content = httpget(url)
	except:
		return [False, 'cntv live2 100']
	try:
		data = json.loads(content)
	except:
		return [False, 'cntv live2 101']
	if data.has_key('hls_url') == False:
		return [False, 'cntv live2 102']
	for item in data['hls_url']:
		url = data['hls_url'][item]
		url = url.replace('vtime.cntv.cloudcdn.net:8000', 'vtime.cntv.cloudcdn.net') #Global (HDS/FLV) - wrong port
		url = url.replace('tv.fw.live.cntv.cn', 'tvhd.fw.live.cntv.cn') #China - 403 Forbidden
		try:
			content = httpget(url)
			break
		except:
			continue
	query = urlparse.parse_qs(urlparse.urlparse(url).query)
	if query.has_key('AUTH') == False:
		return [False, 'cntv live2 103']
	auth = query['AUTH'][0]
	url = url + '|' + urllib.urlencode( { 'Cookie' : 'AUTH=' + auth } )
	return [True, url]

def play(url):
	try:
		content = httpget(url)
	except:
		return [False, 'cntv play 100']
	videoCenterId = re.search('"videoCenterId","(.*?)"', content)
	if videoCenterId == None:
		return [False, 'cntv play 101']
	videoCenterId = videoCenterId.group(1)
	url = 'http://vdn.apps.cntv.cn/api/getHttpVideoInfo.do?pid=' + videoCenterId
	try:
		content = httpget(url)
	except:
		return [False, 'cntv play 102']
	try:
		data = json.loads(content)
	except:
		return [False, 'cntv play 103']
	try:
		title = data['title']
		chapters = data['video']['chapters']
	except:
		return [False, 'cntv play 104']
	urls = []
	for chapter in chapters:
		try:
			suburl = chapter['url']
		except:
			return [False, 'cntv play 105']
		urls.append(suburl)
	return [title, urls]

def list1(url):
	try:
		content = httpget(url)
	except:
		return [False, 'cntv list1 000']
	items = []
	m = re.search('http://api\.cntv\.cn/lanmu/videolistByColumnId\?id=(.*?)&', content, re.DOTALL)
	if m == None:
		return [False, 'cntv list1 001']
	url = 'http://api.cntv.cn/lanmu/videolistByColumnId?id=' + m.group(1) + '&serviceId=tvcctv&type=0&n=36&p=1&t=jsonp&cb=?'
	try:
		content = httpget(url)
	except:
		return [False, 'cntv list1 002']
	m = re.search('.*?\((.*)\).*?', content, re.DOTALL)
	if m == None:
		return [False, 'cntv list1 003']
	content = m.group(1)
	try:
		data = json.loads(content)
	except:
		return [False, 'cntv list1 004']
	for elem in data['response']['docs']:
		items.append([elem['videoTitle'], elem['videoUrl'], False])
	return [items]

def list2(url):
	try:
		content = httpget(url)
	except:
		return [False, 'cntv list2 000']
	items = []
	m = re.findall('<ul class=".*?".*?">(.*?)</ul>', content, re.DOTALL)
	for e in m:
		m1 = re.findall('<li>(.*?)</li>', e, re.DOTALL)
		for e1 in m1:
			m2 = re.search('<div class="text">\s*<a\s+href="(.*?)".*?>(.*?)</a>\s*</div>', e1, re.DOTALL)
			if m2 == None:
				continue
			items.append([m2.group(2), m2.group(1), False])
	return [items]
